config/routes.rb
AlteredBeast::Application.routes.draw do
  get '/session' => "sessions#create", :as => 'open_id_complete'

  resources :sites, :moderatorships, :monitorship

  resources :forums do
    resources :topics do
      resources :posts
      resource :monitorship
    end
    resources :posts
  end

  resources :posts do
    get :search, :on => :collection
  end
  resources :users do
    member do
      put :suspend, :make_admin, :unsuspend
      get :settings
      delete :purge
    end
    resources :posts, :only => [:index] do
#      get :monitored, :on => :collection, :shallow => true
    end
  end
  match '/users/:user_id/monitored(.:format)' => 'posts#monitored', :as => 'monitored_posts'

  match '/activate/:activation_code' => 'users#activate', :activation_code => nil, :as => 'activate'
  match '/signup' => 'users#new', :as => 'signup'
  match '/settings' => 'users#settings', :as => 'settings'
  match '/login' => 'sessions#new', :as => 'login'
  match '/logout' => 'sessions#destroy', :as => 'logout'
  match '/itex'  => 'itex#index'
  delete '/monitorship/:forum_id/:topic_id' => 'monitorships#destroy', :as => 'monitorship' 
  match '/monitorship/:forum_id/:topic_id' => 'monitorships#create', :as => 'monitorship' 

  resource  :session

  root :to => 'forums#index'
end

app/models/user.rb
class User < ActiveRecord::Base
  concerned_with :states, :activation, :posting, :validation
  formats_attributes :bio

  belongs_to :site, :counter_cache => true
  validates_presence_of :site_id

  has_many :posts, :order => "#{Post.table_name}.created_at desc", :dependent => :delete_all
  has_many :topics, :order => "#{Topic.table_name}.created_at desc", :dependent => :delete_all

  has_many :moderatorships, :dependent => :delete_all
  has_many :forums, :through => :moderatorships, :source => :forum do
    def moderatable
      select("#{Forum.table_name}.*, #{Moderatorship.table_name}.id as moderatorship_id")
    end
  end

  has_many :monitorships, :dependent => :delete_all
  has_many :monitored_topics, :through => :monitorships, :source => :topic, :conditions => {"#{Monitorship.table_name}.active" => true}

  has_permalink :login, :scope => :site_id

  attr_readonly :posts_count, :last_seen_at

  scope :named_like, lambda { |name| where("users.display_name like ? or users.login like ?", "#{name}%", "#{name}%") }

  class << self

    def prefetch_from(records)
      select("distinct *").where(:id => records.collect(&:user_id).uniq)
    end

    def index_from(records)
      prefetch_from(records).index_by(&:id)
    end

  end

  def available_forums
    @available_forums ||= site.ordered_forums - forums
  end

  def moderator_of?(forum)
    !!(admin? || Moderatorship.exists?(:user_id => id, :forum_id => forum.id))
  end

  def display_name
    n = read_attribute(:display_name)
    n.blank? ? login : n
  end

  alias_method :to_s, :display_name

  # this is used to keep track of the last time a user has been seen (reading a topic)
  # it is used to know when topics are new or old and which should have the green
  # activity light next to them
  #
  # we cheat by not calling it all the time, but rather only when a user views a topic
  # which means it isn't truly "last seen at" but it does serve it's intended purpose
  #
  # This is now also used to show which users are online... not at accurate as the
  # session based approach, but less code and less overhead.
  def seen!
    now = Time.now.utc
    self.class.where(:id => id).update_all(:last_seen_at => now)
    write_attribute(:last_seen_at, now)
  end

  def to_param
    id.to_s # permalink || login
  end

  def openid_url=(value)
    write_attribute :openid_url, value.blank? ? nil : OpenID.normalize_url(value)
  end

  def using_openid
    self.openid_url.blank? ? false : true
  end

  def to_xml(options = {})
    options[:except] ||= []
    options[:except] += [:email, :login_key, :login_key_expires_at, :password_hash, :openid_url, :activated, :admin]
    super
  end
end

app/models/user/activation.rb
class User
  include Authentication
  include Authentication::ByPassword
  include Authentication::ByCookieToken

  after_create :set_first_user_as_activated
  def set_first_user_as_activated
    register! && activate! if site.nil? or site.users.count <= 1
  end

  # Returns true if the user has just been activated.
  def recently_activated?
    @activated
  end

  def active?
    # the existence of an activation code means they have not activated yet
    activation_code.nil? || activation_code.blank?
  end

end

app/models/user/editable.rb
module User::Editable
  def editable_by?(user, is_moderator = nil)
    is_moderator = user.moderator_of?(forum) if is_moderator.nil?
    user && (user.id == user_id || is_moderator)
  end
end

app/models/user/posting.rb
class User
  # Creates new topic and post.
  # Only..
  #  - sets sticky/locked bits if you're a moderator or admin 
  #  - changes forum_id if you're an admin
  #
  def post(forum, attributes)
    Topic.new(attributes) do |topic|
      topic.forum = forum
      topic.user  = self
      revise_topic topic, attributes, moderator_of?(forum)
    end
  end

  def reply(topic, body)
    topic.posts.build(:body => body).tap do |post|
      post.site  = topic.site
      post.forum = topic.forum
      post.user  = self
      post.save
    end
  end

  def revise(record, attributes)
    is_moderator = moderator_of?(record.forum)
    return unless record.editable_by?(self, is_moderator)
    case record
      when Topic then revise_topic(record, attributes, is_moderator)
      when Post  then post.save
      else raise "Invalid record to revise: #{record.class.name.inspect}"
    end
    record
  end

  protected

    def revise_topic(topic, attributes, is_moderator)
      topic.title = attributes[:title] if attributes.key?(:title)
      topic.sticky, topic.locked, topic.forum_id = attributes[:sticky], attributes[:locked], attributes[:forum_id] if is_moderator
      topic.save
    end
end

app/models/user/states.rb
class User
  acts_as_state_machine :initial => :passive
  state :passive
  state :pending, :enter => :do_activation
  state :active,  :enter => :do_activate
  state :suspended
  state :deleted, :enter => :do_delete

  event :register do
    transitions :from => :passive, :to => :pending, :guard => Proc.new {|u| !(u.crypted_password.blank? && u.password.blank?) }
  end

  event :activate do
    transitions :from => :pending, :to => :active 
  end

  event :suspend do
    transitions :from => [:passive, :pending, :active], :to => :suspended, :guard => :remove_moderatorships
  end

  event :delete do
    transitions :from => [:passive, :pending, :active, :suspended], :to => :deleted
  end

  event :unsuspend do
    transitions :from => :suspended, :to => :active,  :guard => Proc.new {|u| !u.activated_at.blank? }
    transitions :from => :suspended, :to => :pending, :guard => Proc.new {|u| !u.activation_code.blank? }
    transitions :from => :suspended, :to => :passive
  end

  def self.authenticate(login, password)
    return nil if login.blank? || password.blank?
    u = find_in_state :first, :active, :conditions => {:login => login}
    u && u.authenticated?(password) ? u : nil
  end

  def do_activation
    self.deleted_at = nil
    self.activation_code = Digest::SHA1.hexdigest( Time.now.to_s.split(//).sort_by {rand}.join )

    UserMailer.signup_notification(self).deliver # unless using_openid
  end

  protected

    def do_delete
      self.deleted_at = Time.now.utc
    end

    def do_activate
      @activated = true
      self.activated_at = Time.now.utc
      self.deleted_at = nil
      self.activation_code = ""

      UserMailer.activation(self).deliver unless using_openid
    end

    def remove_moderatorships
      moderatorships.delete_all
    end
end

app/controllers/users_controller.rb
require 'itex_stringsupport'

class UsersController < ApplicationController
  before_filter :admin_required, :only => [:suspend, :unsuspend, :destroy, :purge, :edit]
  before_filter :find_user, :only => [:update, :show, :edit, :suspend, :unsuspend, :destroy, :purge]
  before_filter :login_required, :only => [:settings, :update]

  # Brainbuster Captcha
  # before_filter :create_brain_buster, :only => [:new]
  # before_filter :validate_brain_buster, :only => [:create]

  def index
    users_scope = if admin?
                    case params[:status]
                    when 'active'
                      :users
                    when 'suspended'
                      :suspended_users
                    when 'pending'
                      :pending_users
                    else
                      :all_users
                    end
                  else
                    :users
                  end
    if params[:q]
      @q = params[:q].purify
      @users = current_site.send(users_scope).named_like(@q).paginate(:page => current_page)
    else
      @users = current_site.send(users_scope).paginate(:page => current_page)
    end
    respond_to do |format|
      format.html { set_content_type_header }
      format.js
    end
  end

  def show
    set_content_type_header
  end

  def new
    @user = User.new
  end

  def create
    cookies.delete :auth_token
    @user = params[:user] ?
             current_site.users.build(params[:user]) :
             # current_site.users.build(User.where(:email => params[:email]).first.login)    
             User.where(:email => params[:email].purify).first
    @user.save if @user.valid?
    @user.register if @user.valid?
    unless @user.new_record?
      redirect_back_or_default(:login)
      flash[:notice] = I18n.t 'txt.activation_required', 
        :default => "Thanks for signing up! Please click the link in your email to activate your account"
    else
      render :action => 'new'
    end
  end

  def settings
    @user = current_user
    set_content_type_header
    render :action => "edit"
  end

  def edit
    set_content_type_header
  end

  def update
    @user = admin? ? find_user : current_user
    respond_to do |format|
      if @user.update_attributes(params[:user])
        flash[:notice] = 'User account was successfully updated.'
        format.html { redirect_to(settings_path) }
        format.xml  { head :ok }
      else
        format.html { render :action => "edit" }
        format.xml  { render :xml => @user.errors, :status => :unprocessable_entity }
      end
    end
  end

  def activate
    # not sure why this was using a symbol. Let's use the real false.
    self.current_user = params[:activation_code].blank? ? false : current_site.all_users.find_in_state(:first, :pending, :conditions => {:activation_code => params[:activation_code]})
    if logged_in?
      current_user.activate!
      flash[:notice] = "Signup complete!"
    end
    redirect_back_or_default(:forums)
  end

  def suspend
    @user.suspend! 
    flash[:notice] = "User was suspended."
    redirect_to users_path
  end

  def unsuspend
    @user.unsuspend! 
    flash[:notice] = "User was unsuspended."
    redirect_to users_path
  end

  def destroy
    User.destroy(@user)
    flash[:notice] = "User was deleted."
    redirect_to users_path
  end

  def purge
    @user.destroy
    redirect_to users_path
  end

  def make_admin
    redirect_back_or_default(:forums) and return unless admin?
    @user = find_user
    @user.admin = (params[:user][:admin] == "1")
    @user.save
    redirect_to @user
  end

  protected

    def find_user
      @user = if admin?
        current_site.all_users.find params[:id]
      elsif current_user && params[:id] == current_user.id
        current_user
      else
        current_site.users.find params[:id]
      end or raise ActiveRecord::RecordNotFound
    end

    def authorized?
      admin? || params[:id].blank? || params[:id] == current_user.id.to_s
    end

    def render_or_redirect_for_captcha_failure
      render :action => 'new'
    end
end

app/helpers/users_helper.rb
module UsersHelper
  # todo: make this use "size" instead of "count" and maybe cache it
  def user_count
    count = current_site.users.count
    I18n.t 'txt.count_users', :count => count, :num => number_with_delimiter(count)
  end

  # todo: cache this?
  def active_user_count
    count = current_site.users.where("posts_count > 0").count
    I18n.t 'txt.count_users_active', :count => count, :num => number_with_delimiter(count)
  end

  # todo: cache this?
  def lurking_user_count
    count = current_site.users.where(:posts_count => 0).count
    I18n.t 'txt.count_users_lurking', :count => count, :num => number_with_delimiter(count)
  end

  #
  # Use this to wrap view elements that the user can't access.
  # !! Note: this is an *interface*, not *security* feature !!
  # You need to do all access control at the controller level.
  #
  # Example:
  # <%= if_authorized?(:index,   User)  do link_to('List all users', users_path) end %> |
  # <%= if_authorized?(:edit,    @user) do link_to('Edit this user', edit_user_path) end %> |
  # <%= if_authorized?(:destroy, @user) do link_to 'Destroy', @user, :confirm => 'Are you sure?', :method => :delete end %> 
  #
  #
  def if_authorized?(action, resource, &block)
    if authorized?(action, resource)
      yield action, resource
    end
  end

  #
  # Link to user's page ('users/1')
  #
  # By default, their login is used as link text and link title (tooltip)
  #
  # Takes options
  # * :content_text => 'Content text in place of user.login', escaped with
  #   the standard h() function.
  # * :content_method => :user_instance_method_to_call_for_content_text
  # * :title_method => :user_instance_method_to_call_for_title_attribute
  # * as well as link_to()'s standard options
  #
  # Examples:
  #   link_to_user @user
  #   # => <a href="/users/3" title="barmy">barmy</a>
  #
  #   # if you've added a .name attribute:
  #  content_tag :span, :class => :vcard do
  #    (link_to_user user, :class => 'fn n', :title_method => :login, :content_method => :name) +
  #          ': ' + (content_tag :span, user.email, :class => 'email')
  #   end
  #   # => <span class="vcard"><a href="/users/3" title="barmy" class="fn n">Cyril Fotheringay-Phipps</a>: <span class="email">barmy@blandings.com</span></span>
  #
  #   link_to_user @user, :content_text => 'Your user page'
  #   # => <a href="/users/3" title="barmy" class="nickname">Your user page</a>
  #
  def link_to_user(user, options = {})
    raise "Invalid user" unless user
    options.reverse_merge! :content_method => :login, :title_method => :login, :class => :nickname
    content_text      = options.delete(:content_text)
    content_text    ||= user.send(options.delete(:content_method))
    options[:title] ||= user.send(options.delete(:title_method))
    link_to content_text, user_path(user), options
  end

  #
  # Link to login page using remote ip address as link content
  #
  # The :title (and thus, tooltip) is set to the IP address 
  #
  # Examples:
  #   link_to_login_with_IP
  #   # => <a href="/login" title="169.69.69.69">169.69.69.69</a>
  #
  #   link_to_login_with_IP :content_text => 'not signed in'
  #   # => <a href="/login" title="169.69.69.69">not signed in</a>
  #
  def link_to_login_with_IP(content_text = nil, options = {})
    ip_addr           = request.remote_ip
    content_text    ||= ip_addr
    options.reverse_merge! :title => ip_addr
    if tag = options.delete(:tag)
      content_tag tag, content_text, options
    else
      link_to content_text, login_path, options
    end
  end

  #
  # Link to the current user's page (using link_to_user) or to the login page
  # (using link_to_login_with_IP).
  #
  def link_to_current_user(options = {})
    if current_user
      link_to_user current_user, options
    else
      content_text = options.delete(:content_text) || 'not signed in'
      # kill ignored options from link_to_user
      [:content_method, :title_method].each{|opt| options.delete(opt)} 
      link_to_login_with_IP content_text, options
    end
  end
end

app/views/users/_captcha.html.erb
<% unless captcha_passed? %>
	<span id="brain_buster_captcha" class="<%= if last_captcha_attempt_failed? then 'captcha_failed' end %>">
	
		<%= hidden_field_tag :captcha_id, @captcha.id %>
		
		<label for="captcha_answer">
			Spam protection: <%= @captcha.question %>
		</label>
		
		<%= text_field_tag :captcha_answer, params[:captcha_answer], :size => 10, :maxlength => 40 %>
		
	</span>
<% end %>

app/views/users/_contact_info.html.erb
<h3><%= I18n.t 'txt.views_users.profile', :default => 'User profile' %></h3>

<p>
  <label for="display_name"><%= I18n.t 'txt.views_users.display_name', :default => 'Display name' %></label><br />
  <%= settings.text_field :display_name %>
</p>

<p>
  <label for="user_openid_url"><%= I18n.t 'txt.views_users.openid_url_title', :default => 'Identity Url' %></label><br />
  <p class="help"><%= I18n.t 'txt.views_users.open_id_field', :default => 'Enter your OpenID Identity Url if you know it.' %></p>
  <%= settings.text_field :openid_url %>
</p>

<p>
  <label for="user_website"><%= I18n.t 'txt.views_users.website_title', :default => 'Website' %></label><br />
  <%= settings.text_field :website %> 
	<span class="entryhelp">
	(<%= I18n.t 'txt.views_users.without_http', :default => 'without http://' %>)
	</span>
</p>

<p>
  <label for="user_bio"><%= I18n.t 'txt.views_users.bio_title', :default => 'Bio' %></label><br />
  <%= settings.text_area :bio, :rows => 10, :style => "width:99%" %>
</p>

app/views/users/_settings.html.erb
<h3><%= I18n.t 'txt.views_users.basics_title', :default => 'Basics' %></h3>

<% if not @user.valid? and @user.errors.on(:login) %>

<p>
  <label for="login"><%= I18n.t 'txt.views_users.login_title', :default => 'Login' %></label></p>
  <p class="help">
    <strong><%=  I18n.t 'txt.views_users.change_login', :default => 'Please change your login' %>.</strong>
    <%=  I18n.t 'txt.views_users.login_field', :default => 'Logins should start with least 2 characters and may consist of letters, numbers, or the underscore' %>.
  </p>
<p>
  <%= settings.text_field :login %>
</p>
<% end %>

<p>
  <label for="user_email"><%=  I18n.t 'txt.views_users.email_title', :default => 'Email' %></label><br />
  <%= settings.text_field :email %>
</p>

<div>
  <label for="user_password"><%=  I18n.t 'txt.views_users.password_title', :default => 'Password' %></label><br />
  <p class="entryhelp" style="margin-top:0.5em;"><%=  I18n.t 'txt.views_users.password_field', :default => 'Enter a new password twice to change your password. (must be longer than 5 characters)' %></p>
  <%= settings.password_field :password, :size => 16 %>
  <span class="entryhelp">(<%=  I18n.t 'txt.views_users.once', :default => 'once' %>)</span><br />
  <%= settings.password_field :password_confirmation, :size => 16 %>
  <span class="entryhelp">(<%=  I18n.t 'txt.views_users.and_again', :default => 'and again' %>)</span>
</div>

app/views/users/_users_list.html.erb
<%= will_paginate @users %>

<table class="wide forums">
  <tr>
    <th class="la" style="width: 88%"><%= I18n.t 'txt.views_users.name_or_login', :default => 'Name / Login' %></th>
	<% if logged_in? && current_user.admin? %>
	<th><%= I18n.t 'txt.views_users.current_status_title', :default => "Current Status" %></th>
	<% end %>
    <th><%= I18n.t 'txt.views_users.website_title', :default => 'Website' %></th>
    <th style="width: 1%"><%= I18n.t 'txt.views_users.posts_title', :default => 'Posts' %></th>
  </tr>
<% @users.each do |user|%>  
  <tr>
    <td><%= link_to user.display_name || user.login, user, :class => (user.admin? ? "admin" : nil) %>
      <span style="color:#666">
      <%= I18n.t('txt.views_users.admin_in_parens', :default => "(admin)") if user.admin? %>
      </span>
	  </td>
	<% if logged_in? && current_user.admin? %>
		<td><%= user.state %></td>
	<% end %>
    <td class="la">
      <% unless user.website.blank? %>
      <%= sanitize link_to(user.website.gsub("http://",""), "http://" + user.website.gsub("http://","")) %>
      <% end %>
    </td>
    <td class="ca inv"><%= user.posts.size %></td>
  </tr>
<% end %>
</table>

<%= will_paginate @users %>

<script type='text/javascript'><!--//--><![CDATA[//><!--
if (history && history.replaceState && $$('.pagination')) {
  $$('.pagination a').invoke('observe', 'click', function(){
      <%= p = Hash.new
       p.update('page' => params[:page].to_i) if params[:page]
       p.update('utf8' => CGI.escape(params[:utf8])) if params[:utf8]
       p.update('q' => CGI.escape(@q)) if @q
       p.update('commit' => CGI.escape(params[:commit])) if params[:commit]
       modify_history('pushState', 'Users', users_path, p) %>
  });
  $$('.pagination a').invoke('writeAttribute','data-remote')
};
//--><!]]></script>

app/views/users/edit.html.erb
<% content_for :right do %>

  <h5><%=  I18n.t 'txt.views_users.avatars_title', :default => 'Avatars' %></h5>
  <p><%= I18n.t('txt.views_users.gravatar_notice_html', :default => 'To have your very own avatar displayed on this forum visit %{gravatar} and sign up for a free gravatar.', :gravatar => '<a href="http://www.gravatar.com/" title="Gravatar - Globally Recognized Avatars">Gravatar</a>').html_safe %></p>

  <% if current_user && current_user.admin? %>
    <%= form_for @user, :url => make_admin_user_path(@user) do |f| %>
      <h5>Admin</h5>
      <p>
        <%= f.check_box :admin %>
        <label for="user_admin"><%= I18n.t 'txt.admin.user_is_an_administrator', :default => 'User is an administrator' %></label>
      </p>
      <p>
        <%= submit_tag 'Save' %>
      </p>
    <% end %>
  <% end %>

<% end %>

<h1><%= I18n.t 'txt.views_users.settings', :default => 'Settings' %></h1>

<p class="subtitle"><%= I18n.t 'txt.views_users.for_user', :default => 'for %{user}', :user => @user.display_name %>
	<% if @user.login!=@user.display_name %>
	(<%= @user.login %>)
	<% end %>
</p>

<%= form_for @user do |f| %>
  <%= f.error_messages %>
  <%= render :partial => "settings", :object => f %>
  <p><%= submit_tag I18n.t('txt.views_users.change_email_or_password', :default => 'Change e-mail or password') %></p>
<% end %>

<br />

<%= form_for @user do |f| %>
  <%= render :partial => "contact_info", :locals => { :settings => f } %>
  <%= submit_tag I18n.t('txt.views_users.update_profile', :default => 'Update profile') %> <%= I18n.t 'txt.or', :default => 'or' %> <%= link_to(I18n.t('txt.cancel', :default => 'Cancel'), user_path(@user)) %>
<% end %>

app/views/users/index.html.erb
<h5><%= I18n.t 'txt.views_users.find_a_user', :default => 'Find a User' %></h5>

<%= form_tag users_path, :method => 'get' do %>
<p>
<label><%= I18n.t 'txt.views_users.display_name_or_login', :default => 'Display name or login' %></label>
<%= text_field_tag :q, @q %> 
<%= submit_tag I18n.t('txt.views_users.search_title', :default => "Search") %></p>
<% end %>

<h1 style="margin-top:0;"><%= I18n.t 'txt.users', :default => 'Users' %></h1>
<p class="subtitle">
  <%= user_count %>: <%= active_user_count %>, <%= lurking_user_count %>
</p>

<% if logged_in? && current_user.admin? %>

<%= form_tag({:action => 'index'}, :method => 'get', :remote => true, :id => 'filter_users') do %>
  <% ['all', 'active', 'suspended', 'pending'].each do |stat| %>
    <%= radio_button_tag(:status, stat, !!(params['status'] == stat || (!params['status'] && stat == 'all')) ) %>
    <%= label_tag("status_#{stat}".to_sym, I18n.t("txt.views_users.#{stat}", :default => stat) ) %>
  <% end %>
  <%= submit_tag("Filter", :id => 'filter_submit') %>
<% end %>
<script type='text/javascript'><!--//--><![CDATA[//><!--
var form = document.getElementById('filter_users');
$('filter_submit').remove();
Event.on(form, 'click', function(event){form.submit();})
//--><!]]></script>

<% end %>

<div id='users_list'>
  <%= render(:partial => 'users_list') %>
</div>

<script type='text/javascript'><!--//--><![CDATA[//><!--
if (history && history.replaceState && $$('.pagination')) {
  Event.observe(window, 'popstate', function(event){
    new Ajax.Request("<%= users_path %>", {method: 'get', parameters: event.state})
  });
};
//--><!]]></script>

app/views/users/index.js.erb
$('users_list').update("<%= escape_javascript(render(:partial => 'users_list'))%>");
<%= p = Hash.new
  p.update('page' => params[:page].to_i) if params[:page]
  p.update('utf8' => CGI.escape(params[:utf8])) if params[:utf8]
  p.update('q' => CGI.escape(@q)) if @q
  p.update('commit' => CGI.escape(params[:commit])) if params[:commit]
  modify_history('replaceState', 'Users', users_path, p) %>

app/views/users/new.html.erb
<%= form_for @user do |f| %>
  <%= f.error_messages %>

  <p><label for="login"><%= I18n.t 'txt.login_name', :default => 'Login' %></label><br/>
  <%= f.text_field :login %></p>

  <p><label for="email"><%= I18n.t 'txt.email', :default => 'Email' %></label><br/>
  <%= f.text_field :email %></p>

  <p><label for="password"><%= I18n.t 'txt.password', :default => 'Password' %></label><br/>
  <%= f.password_field :password %></p>

  <p><label for="password_confirmation"><%= I18n.t 'txt.password_confirm', :default => 'Confirm Password' %></label><br/>
  <%= f.password_field :password_confirmation %></p>

  <p><label for="user_openid_url"><%= I18n.t 'txt.openid_url', :default => "OpenID URL (optional)" %></label><br />
  <%= f.text_field :openid_url %>
  </p>

  <%#= render :partial => 'captcha' # enable for brainbuster %>

  <p><%= submit_tag I18n.t('txt.sign_up', :default => 'Sign up') %></p>

<% end %>

app/views/users/show.html.erb
<% @page_title = @user.display_name %>

<% content_for :right do %>
<% if admin? %>
<% if @user.active? && !@user.suspended? %>
  <%= form_for @user.moderatorships.build do |f| %>
    <h6><%= I18n.t 'txt.admin.admin_and_moderation', :default => 'Admin & Moderation' %></h6>

    <% if @user.forums.present? %>

    <p><%= I18n.t 'txt.admin.remove_moderated_forum', :default => 'This user can moderate the following forums. Click one to remove.' %></p>

    <ul class="flat">
    <% @user.forums.moderatable.each do |forum| %>
      <li>
        <%= link_to forum.name, moderatorship_path(forum.moderatorship_id), :method => :delete, :confirm => I18n.t('txt.admin.remove_user_as_moderator', :default => 'Remove user as moderator for %{forum}?', :forum => forum.name) %>
      </li>
    <% end %>
    </ul>
    <% end %>

  	<% if @user.available_forums.present? %>
    <p>
  	<label><%= I18n.t 'txt.admin.add_as_moderator', :default => 'Add as moderator' %></label><br />
  	<%= f.collection_select :forum_id, @user.available_forums, :id, :name, :include_blank => " - " %>
  	</p>
    <p>
  		<%= f.submit I18n.t 'txt.save', :default => 'Save' %>
  		<%= f.hidden_field :user_id %>
  	</p>
  	<% end %>
  <% end %>

  <p><%= link_to I18n.t('txt.admin.suspend_user_account', :default => "Suspend user account"), suspend_user_path(@user), :method => :put %></p>

<% else %>
  <p><%= I18n.t 'txt.admin.user_account_is_suspended', :default => "User account is suspended" %>. <%= link_to I18n.t('txt.admin.unsuspend_user_account', :default => "Unsuspend user account"), unsuspend_user_path(@user), :method => :put %></p>
<% end %>
<p><%= link_to I18n.t('txt.admin.edit_user_account', :default => "Edit user account"), edit_user_path(@user) %></p>
<p><%= link_to I18n.t('txt.admin.delete_user_account', :default => "Delete user account"), user_path(@user), :method => :delete,
   :confirm => I18n.t('txt.admin.delete_user_sure', :default => 'Delete this user forever?') %></p>
<% end %>
<% end %>

<p style="float:right;"><%= avatar_for @user, 80 %></p> 

<h1><%= @user.display_name %></h1>

<p class="subtitle">
  <%= feed_icon_tag @user.display_name, user_posts_path(:user_id => @user, :format => :rss) %>
  <span>
    <%= I18n.t 'txt.count_topics', :count => @user.topics.size, :num => number_with_delimiter(@user.topics.size) %>,
    <%= I18n.t 'txt.count_posts', :count => @user.posts.size, :num => number_with_delimiter(@user.posts.size) %>
    (<%= I18n.t 'txt.view', :default => 'view' %>
     <%= link_to I18n.t('txt.all', :default => 'all'), user_posts_path(@user) %> <% if logged_in? %>|
     <%= link_to I18n.t('txt.monitored', :default => 'monitored'), user_posts_path(@user, :monitored => true) %> <%= I18n.t 'txt.posts', :default => 'posts' %><% end %>)<br />
  </span>
</p>

<%= @user.bio_html.html_safe if @user.bio_html  %>

<% unless @user.website.blank? %>
<p><strong><%= I18n.t 'txt.website', :default => 'Website' %></strong> <%= sanitize link_to(@user.website.gsub("http://",""), "http://" + @user.website.gsub("http://","")) %></p>
<% end %>
<p><%= I18n.t 'txt.user_since', :default => 'User since %{date}', :date => @user.created_at.to_date.to_s(:long) %></p>